=== debian/changelog ===
ogre-2.2 (2.2.5+20210824~ec3f70c-4osrf~buster) buster; urgency=medium

  * New compilation flags from
    https://github.com/ignition-forks/ogre-2.2-release/pull/4

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 19 Oct 2021 20:51:27 +0200

ogre-2.2 (2.2.5+20210824~ec3f70c-4osrf~buster) focal; urgency=medium

  * New compilation flags from
    https://github.com/ignition-forks/ogre-2.2-release/pull/4

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 19 Oct 2021 20:51:27 +0200

ogre-2.2 (2.2.5+20210824~ec3f70c-3) buster; urgency=medium

  * Stable release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 27 Aug 2021 12:49:19 +0200

ogre-2.2 (2.2.5+20210824~ec3f70c-3) bionic; urgency=medium

  * Stable release

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 27 Aug 2021 12:49:19 +0200

ogre-2.2 (2.2.5+20210824~ec3f70c-2) bionic; urgency=medium

  * Build ogre-2.2 with rapidjson support

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 27 Aug 2021 12:48:46 +0200

ogre-2.2 (2.2.5+20210824~ec3f70c-1) bionic; urgency=medium

  * New upstream version 2.2.5+20210824~ec3f70c

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 24 Aug 2021 19:11:16 +0200

ogre-2.2 (2.1.9999~20210319~3aa42f-1) focal; urgency=medium

  * Focal version

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 23 Mar 2021 17:06:28 +0100

ogre-2.2 (2.1.9999~20210319~3aa42f-1) bionic; urgency=medium

  * New upstream version 2.1.9999~20210319~3aa42f

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 19 Mar 2021 20:08:54 +0100
